#include <bits/stdc++.h>
using namespace std;
#define ll long long

ll A[100000005];
int br = 0;

bool Xor(int a, int b){
    return a^b;
}

bool And(int a, int b){
    return a&b;
}

int main(){
    int n, q;
    cin >> n >> q;
    for(int i = 1; i <= n; i++){
        cin >> A[i];
    }

    for(int o = 1; o <= q; o++){
        int l, r;
        cin >> l >> r;
        for(int i = l; i <= r; i++){
                int j = i;
                if((And(A[i], A[j]) > Xor(A[i], A[j])) == true) br++;
                j++;
                if((And(A[i], A[j]) > Xor(A[i], A[j])) == true) br++;
            }
        }
        cout << br;
    };

    return 0;
}